<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8" />
	<title>ITEA-JS ADVANCED - LESSON 2: TASK 2</title>
	<link rel="stylesheet" href="css/style.min.css" />
</head>
<body>
	<div class="wrap">
		<div class="testBlock hover">
		<button class="iButton" id="mouseHover">1. Hover!</button>
		<ul id="hoverResult" class="resultBlock">
			<li class="red">Hovered!</li>
			<li class="blue">Hovered!</li>
		</ul>
		</div>

		<div class="testBlock click">
		<button class="iButton" id="mouseClick">2. Click for do things</button>
		<div id="clickResult" class="resultBlock one two three four five six"></div>
		</div>

		<div class="testBlock random">
		<button class="iButton" id="mouseLight">3. Click for turn on lights</button>
		<div id="lightResult" class="resultBlock"></div>
		</div>

		<div class="testBlock keyboard">
		<button class="iButton" id="keyboardButton">4. Press any key</button>
		<div id="keyboardResult" class="resultBlock key-colors"></div>
		</div>

	</div>

<script>
    /*
		Поработаем немного с ивентами:
		onmouseenter
		onclick
		oncontextmenu
		onkeydown

		Задание:
		На каждую из конопок назначить действие которое будет выполнять следующее действие:
		1.На ховер(onmouseenter) повесить обработчик который будет при каждом наведении
		на кнопку будет выводить в блок результатом елемент li с текстом "hovered!"
		у которого будет один из следующих класов:
		red blue green orange purple

		2.На кнопку клика (onclick) повесить обработчик который будет удалять классы с
		блока с результатом по очереди в таком порядке:

		six > two > three > four > one > five
		после того как блок окажется пустым, добавить их в порядке возрастания
		one > two > three ... > six

		3. На кнопку клика (Light) повесить обработчик, который будет выводить в 
		блок с результатом (lightResult) поочередно один из цветов светофора:
		Цикл: Off -> Red -> Yellow -> Green -> Off -> Red -> Yellow 
		styles!

		4. На кнопку с обработчиком нажатия (onkeydown) повесить обработчик который будет:
		- Выводить в блок с результатом(keyboardResult) число нажатий на любую из клавиш клавиатуры.
		- Давать блоку (keyboardResult) классы, которые соотсветствуют числу кликов:

		Н-р:
		1 -> one
		3 -> three
		5 -> five
		11 -> one one
		115 -> one one five

	*/

	let mouseHover = document.getElementById('mouseHover');
	let mouseClick = document.getElementById('mouseClick');
	let mouseLight = document.getElementById('mouseLight');
	let keyboardButton = document.getElementById('keyboardButton');
	// 1.
	mouseHover.onmouseenter = function(){
		let colors = ['red', 'blue', 'green', 'orange', 'purple'];

		const liElement = document.createElement('li');
		liElement.innerText = "hovered!";
		const randomColor = getRandomFromArray(colors);
		liElement.className = randomColor;

		const result = document.getElementById("hoverResult");
		result.appendChild(liElement,randomColor)
		console.log('hover',randomColor);
	}
	//2.
	let clickIndex = 0;
	let direction = true;

	mouseClick.onclick = function(){
		const element = document.getElementById("clickResult");
		classesToDelete = ['six', 'two', 'three', 'four', 'one' ,'five'];
		classesToAdd = ['one', 'two', 'three', 'four', 'five' ,'six'];

		if(clickIndex >= 0 && clickIndex <= classesToDelete.length -1) {
			element.classList.remove(classesToDelete[clickIndex]);
			clickIndex ++;
		}
		else if(clickIndex >= classesToDelete.length && clickIndex <= classesToDelete.length + classesToAdd.length -1) {
			element.classList.add(classesToAdd[clickIndex - classesToDelete.length]);
			if(clickIndex >= classesToDelete.length + classesToAdd.length -1) {
				clickIndex = 0;
			} else {
				clickIndex++;
			}
		}
		
		console.log('click', clickIndex);
	}

	// 3. 
	mouseLight.onclick = function(e){
		const lightResult = document.getElementById("lightResult");
		lightResult.style.backgroundColor = getNextColor();
		console.log('light');
	}

	// 4.
	let counter = 0;
	const keyboardResultElement = document.getElementById("keyboardResult");
	const keyboardResultElementClasses = keyboardResultElement.className;
	keyboardButton.onkeydown = function(){
		
		keyboardResultElement.innerText = ++counter;
		keyboardResultElement.className =  keyboardResultElementClasses + ' ' + getNumberNames(counter);
		console.log('keydown');
	}

	// 1.

	function getRandomIntInclusive(min, max) {
		min = Math.ceil(min);
		max = Math.floor(max);
		return Math.floor(Math.random() * (max - min + 1)) + min;
	}

	function getRandomFromArray(array) {
		return array[getRandomIntInclusive(0, array.length -1)];
	}

	//3.
	let currentColor = 0;
	const colors = ['Off', 'Red', 'Yellow',  'Green', 'Off',  'Red', 'Yellow'];
	function getNextColor(){
		result = colors[currentColor];
		if (result == 'Off') {
			result = '';
		}

		if(currentColor >= colors.length -1) {
			currentColor = 0;
		} else {
			currentColor++;
		}

		return result;
	}

	// 4. 
	function getNumberNames(number){
		const numberNames = ['zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine'];
		let resultNumbers = [];
		number = '' + number;
		for(let i = 0; i <=  number.length - 1; i++ ){
			resultNumbers.push(number[i]); 
		}

		let result = '';

		for(let i= 0; i < resultNumbers.length; i++) {
			result += numberNames[resultNumbers[i]];
			if (i != resultNumbers.length - 1) {
				result += ' ';
			}
		}

		return result;
	}
</script>
</body>
</html>
